Blame support/tst-support_record_failure-2.sh

Packit 6c4009
#!/bin/sh
Packit 6c4009
# Test failure recording (with and without --direct).
Packit 6c4009
# Copyright (C) 2016-2018 Free Software Foundation, Inc.
Packit 6c4009
# This file is part of the GNU C Library.
Packit 6c4009
Packit 6c4009
# The GNU C Library is free software; you can redistribute it and/or
Packit 6c4009
# modify it under the terms of the GNU Lesser General Public
Packit 6c4009
# License as published by the Free Software Foundation; either
Packit 6c4009
# version 2.1 of the License, or (at your option) any later version.
Packit 6c4009
#
Packit 6c4009
# The GNU C Library is distributed in the hope that it will be useful,
Packit 6c4009
# but WITHOUT ANY WARRANTY; without even the implied warranty of
Packit 6c4009
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Packit 6c4009
# Lesser General Public License for more details.
Packit 6c4009
#
Packit 6c4009
# You should have received a copy of the GNU Lesser General Public
Packit 6c4009
# License along with the GNU C Library; if not, see
Packit 6c4009
# <http://www.gnu.org/licenses/>.  */
Packit 6c4009
Packit 6c4009
set -e
Packit 6c4009
Packit 6c4009
common_objpfx=$1; shift
Packit 6c4009
test_program_prefix_before_env=$1; shift
Packit 6c4009
run_program_env=$1; shift
Packit 6c4009
test_program_prefix_after_env=$1; shift
Packit 6c4009
Packit 6c4009
run_test () {
Packit 6c4009
    expected_status="$1"
Packit 6c4009
    expected_output="$2"
Packit 6c4009
    shift 2
Packit 6c4009
    args="${common_objpfx}support/tst-support_record_failure $*"
Packit 6c4009
    echo "running: $args"
Packit 6c4009
    set +e
Packit 6c4009
    output="$(${test_program_prefix_before_env} \
Packit 6c4009
		 ${run_program} ${test_program_prefix_after_env} $args)"
Packit 6c4009
    status=$?
Packit 6c4009
    set -e
Packit 6c4009
    echo "  exit status: $status"
Packit 6c4009
    if test "$output" != "$expected_output" ; then
Packit 6c4009
	echo "error: unexpected output: $output"
Packit 6c4009
	exit 1
Packit 6c4009
    fi
Packit 6c4009
    if test "$status" -ne "$expected_status" ; then
Packit 6c4009
	echo "error: exit status $expected_status expected"
Packit 6c4009
	exit 1
Packit 6c4009
    fi
Packit 6c4009
}
Packit 6c4009
Packit 6c4009
different_status () {
Packit 6c4009
    direct="$1"
Packit 6c4009
    run_test 1 "error: 1 test failures" $direct --status=0
Packit 6c4009
    run_test 1 "error: 1 test failures" $direct --status=1
Packit 6c4009
    run_test 2 "error: 1 test failures" $direct --status=2
Packit 6c4009
    run_test 1 "error: 1 test failures" $direct --status=77
Packit 6c4009
    run_test 2 "error: tst-support_record_failure.c:109: not true: false
Packit 6c4009
error: 1 test failures" $direct --test-verify
Packit 6c4009
    run_test 2 "error: tst-support_record_failure.c:109: not true: false
Packit 6c4009
info: execution passed failed TEST_VERIFY
Packit 6c4009
error: 1 test failures" $direct --test-verify --verbose
Packit 6c4009
}
Packit 6c4009
Packit 6c4009
different_status
Packit 6c4009
different_status --direct
Packit 6c4009
Packit 6c4009
run_test 1 "error: tst-support_record_failure.c:116: not true: false
Packit 6c4009
error: 1 test failures" --test-verify-exit
Packit 6c4009
# --direct does not print the summary error message if exit is called.
Packit 6c4009
run_test 1 "error: tst-support_record_failure.c:116: not true: false" \
Packit 6c4009
	 --direct --test-verify-exit